#!/usr/bin/perl -I/usr/sausalito/perl

use strict;
use Sauce::Util;
use CCE;
#use Animal;

# create and connect a CCE Client
my $cce = new CCE();
$cce->connectfd(\*STDIN, \*STDOUT);

my $oid;  $oid = $cce->event_oid();
my $old;  $old = $cce->event_old();
if (!$old) {
	$cce->warn("[[slush-barn.errorReadingOldObject]]");
	$cce->bye("FAIL");
	exit;
}
my $new;  $new = $cce->event_object();
if (!$new) {
	$cce->warn("[[slush-barn.errorReadingNewObject]]");
	$cce->bye("FAIL");
	exit;
}


#define start and stop lines
my $startLine = "<class type=\"".$old->{type}."\">";
my $endLine =   "</class>";
my $oldname = $old->{name};
my $newname = $new->{name};

# WARNING, get ready for a mess..
if ($old->{type} eq "" && $old->{name} eq "") {
	#new object
	$startLine = "<class type=\"".$new->{type}."\">";
	$oldname = "";
} elsif ($new->{type} eq "" && $new->{name} eq "") {
	# slaughtering animal
	$newname = "";
} else {
	# change in types
	doit( $startLine, $endLine, $oid, "", $oldname);
	$startLine = "<class type=\"".$new->{type}."\">";
	$oldname = "";
}
doit( $startLine, $endLine, $oid, $newname, $oldname);
$cce->bye("SUCCESS");

sub doit {
	# hardcoded defines
	my $CONFFILE = "/etc/barn.conf";
	my $startLine = shift;
	my $endLine = shift;
	my $oid = shift;
	my $newname = shift;
	my $oldname = shift;
	Sauce::Util::editblock( $CONFFILE, \&editBlock, $startLine, $endLine, $oid, $newname, $oldname);
}
sub editBlock {
	my $fin = shift;
	my $fout = shift;
	my $oid = shift;
	my $name = shift;
	my $oldname = shift;

	while (<$fin>) {
		if (/^\s*<animal\s*oid=\"$oid\"\s*name="$oldname"/) {
			if (!($name eq "")) {
				print $fout "\t<animal oid=\"$oid\" name=\"$name\"/>\n";
			}
		} else {
			print $fout $_;
		}
	}
	if ($oldname eq "") {
		print $fout "\t<animal oid=\"$oid\" name=\"$name\"/>\n";	
	}
}
