<?

/*
 / Includes:
*/

include("ServerScriptHelper.php");

/*
 / Initialize Objects:
*/

$serverScriptHelper = new ServerScriptHelper();
$cce = $serverScriptHelper->getCceClient();
$factory =  $serverScriptHelper->getHtmlComponentFactory("slush-barn");
$i18n = $serverScriptHelper->getI18n("slush-barn");
$page = $factory->getPage();
$scrollList = $factory->getScrollList("scrollListLabel", array( "name", "animal", "actions"), array(0,1));
/* set custom counts */
$scrollList->setEntryCountTags("[[slush-barn.singularCount]]", "[[slush-barn.pluralCount]]");
$scrollList->setAlignments(array("left", "left", "center"));
$scrollList->setColumnWidths(array("", "", "1%"));

/*
 / Find all the animals from CCE and Loop through them getting their values 
 / and plugging them into the scrollList
*/

$animals = $cce->find("BarnAnimal");

while (list($key, $oid) = each($animals)) {

	/*
	 / Insert Fields into the PagedBlock
	*/

	$animal = $cce->get($oid);

	$scrollList->addEntry( array(
		$factory->getTextField("name" . $oid, $animal["name"], "r"),
		$factory->getTextField("animal" . $oid, $animal["type"], "r"),
		$factory->getCompositeFormField( array(
			$factory->getModifyButton("/slush/barn/animal.php?oid=$oid"),
			$factory->getRemoveButton("javascript: slaughterCheck('$oid')")
		))
	));
	
}

/* 
 / Create an 'Add button 
*/

$addButton = $factory->getAddButton("animal.php");

$scrollList->addButton($addButton);
/*
 / Print the entire page and contents 
*/

print $page->toHeaderHtml();
/* add javascript functions here: */
?>
<SCRIPT language="Javascript">
function slaughterCheck(oid) {
	if (confirm("<? /* i18n message */ print $i18n->get("checkSlaughter")?>")) {
		location = "/slush/barn/slaughter.php?oid=" + oid;
	}
}
</SCRIPT>
<?
print $scrollList->toHtml();
print $page->toFooterHtml();
?>
